let uid, rid, token, client, width, height;
const appkey = "d5ecd0329d418cba4cadef3f58814db6";

const startDom = document.getElementById("start");
const endDom = document.getElementById("end");

const start = async () => {
  client = NERTC.createClient({ appkey, debug: true });
  // 监听事件
  client.on("stream-added", (event) => {
    const remoteStream = event.stream;
    console.warn(
      "收到别人的发布消息: ",
      remoteStream.streamID,
      "mediaType: ",
      event.mediaType
    );
    //订阅远端流
    client.subscribe(remoteStream).then(() => {
      console.warn(`subscribe 成功 ${remoteStream.streamID}`);
    });
  });
  client.on("stream-subscribed", (event) => {
    // 远端流订阅成功
    const remoteStream = event.stream;
    console.warn(
      "订阅别人的流成功的通知: ",
      remoteStream.streamID,
      "mediaType: ",
      event.mediaType
    );
    const dom = document.getElementById("remote-container");
    if (dom?.offsetWidth) {
      width = dom.offsetWidth;
    }
    if (dom?.offsetHeight) {
      height = dom.offsetHeight;
    }
    console.log("dom--------------", width, height);

    // 设置远端视频画布remote-container
    remoteStream.setRemoteRenderMode({
      width: width,
      height: height,
    });
    // 播放远端流
    remoteStream.play("remoteVideoContent");
  });
  // 进房成功后开始推流
  try {
    await client.join({ channelName: rid, uid: uid, token: token });
    remoteStream();
  } catch (error) {
    console.error(error);
    alert(error?.msg || "进房失败");
  }
};

const remoteStream = async () => {
  client.on("peer-online", (evt) => {
    console.log(`${evt.uid} 加入房间`);
  });

  client.on("stream-added", (evt) => {
    var remoteStream = evt.stream;
    console.log(
      "收到别人的发布消息: ",
      remoteStream.streamID,
      "mediaType: ",
      evt.mediaType
    );

    //设置要订阅音频或者视频
    remoteStream.setSubscribeConfig({
      audio: true, //订阅麦克风音频
      audioSlave: true, //订阅音频辅流
      video: true, //订阅视频
      screenShare: true, //订阅屏幕共享
      highOrLow: NERTC.STREAM_TYPE.HIGH, //订阅大流
    });
    //发起订阅
    client.subscribe(remoteStream).then(() => {
      console.log("发起订阅对端成功");

      //播放订阅的对端的音视频流
      client.on("stream-subscribed", (evt) => {
        console.warn("订阅别人的流成功的通知");
        var remoteStream = evt.stream;
        let div = document.getElementById("remote-container");
        //开始播放远端音视频流
        remoteStream.play(div).then(() => {
          console.log("播放对端的流成功");
          console.log(height, "height");
          remoteStream.setRemoteRenderMode({
            width: width,
            height: height,
            cut: false,
          });
        });
      });
    });
  });
};

const finish = async () => {
  await client?.leave();
};

endDom.addEventListener("click", finish);
startDom.addEventListener("click", () => {
  rid = document.getElementById("rid").value;
  token = document.getElementById("token").value;
  uid = document.getElementById("tokenId").value;
  console.log(rid);
  start();
});
